%define name		em8300
%define name_devel	em8300-devel
%define name_kmods	em8300-kmods
%define version	0.15.0
%define release	1
%define builddir	$RPM_BUILD_DIR/%{name}-%{version}

Name:		%{name}
Version:	%{version}
Release:	%{release}
Vendor:	http://dxr3.sourceforge.net/
Packager:	Andrew Meredith <andrew@anvil.org>
URL:		http://www.anvil.org/%{name}
Source:	%{name}-%{version}.tar.gz
Group:		Development/Libraries
Copyright:	GPL
BuildRoot:	%{_tmppath}/%{name}-%{version}
Prefix:		%{_prefix}
Summary:	Library for Hollywood plus / DXR3 device driver for Linux

%description
This contains shared objects that can be used by packages
developed for use with the Hollywood plus or DXR3 MPEG
decoder cards.

For futher info. see http://dxr3.sourceforge.net/

%package devel
Summary: Development Libraries & includes for Hollywood plus / DXR3 device driver for Linux
Group: Development/Libraries

%description devel
This contains the development libraries used when
building an application that will make use of the
shared objects in the em8300 package.

%package kmods
Summary: Modules and boot self build for Hollywood plus / DXR3 device driver for Linux
Group: Development/Libraries
Provides: perl(em8300)

%description kmods
This contains the source code for the modules that drive
the Hollywood plus and DXR3 devices. it also contains
a System V initialisation script that modprobes the
drivers on boot. If the modprobe fails, it will try and
rebuild the drivers on the fly.

%prep
%setup -n %{name}-%{version}

%build
CFLAGS="${RPM_OPT_FLAGS}" LDFLAGS=-s

%configure
make

%install
if [ -d $RPM_BUILD_ROOT ]; then rm -rf $RPM_BUILD_ROOT; fi
mkdir -p $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

%pre

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%post kmods
%{prefix}/share/em8300/em8300.sysv install
%{prefix}/share/em8300/em8300.sysv restart

%preun kmods
%{prefix}/share/em8300/em8300.sysv stop
%{prefix}/share/em8300/em8300.sysv uninstall

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
/usr/bin/*
/usr/lib/*so*
%doc README NEWS AUTHORS COPYING ChangeLog INSTALL

%files devel
%defattr(-,root,root)
/usr/include/libdxr3/
/usr/include/linux/*
/usr/lib/*.a
/usr/lib/*.la

%files kmods
%defattr(-,root,root)
/usr/share/em8300/

%changelog
* Tue Sep 25 2001 Andrew Meredith <andrew@anvil.org>
- Removed extranious line from devel file list.

* Tue Sep 25 2001 Akos Szabo <fonya@fatav.hu>
- Remove docs section from kmods, and devel
- Added Provides to the kmods

* Tue Mar 13 2001 Andrew Meredith <andrew@anvil.org>
- Added em8300-kmods package

* Mon Mar 12 2001 Andrew Meredith <andrew@anvil.org>
- First draft of rpm package for em8300 including
  both main em8300 and em8300-devel.

