/*
    cx25840 driver functions

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <linux/i2c.h>

extern int debug;
extern int cx25840_fast_fw_load;
extern char *cx25840_fw;

void cx25840_write_setting(struct i2c_client *client, u16 setting, u32 value);
u32 cx25840_read_setting(struct i2c_client *client, u16 setting);

#define CX25840_DEBUG(args...) \
	do { \
		if (debug) \
			printk(KERN_INFO "cx25840 debug: " args); \
	} while (0)

#define CX25840_ERR(args...) printk(KERN_ERR "cx25840: " args);
#define CX25840_INFO(args...) printk(KERN_INFO "cx25840: " args);

#define VIDEO_IS_PRESENT 1
#define VIDEO_NOT_PRESENT 2

#define CX25840_SVIDEO 0
#define CX25840_COMPOSITE 1
#define CX25840_TUNER 2
#define CX25840_FM 3
#define CX25840_AUDIOIN 4
