/*
    cx25840 firmware functions

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <linux/i2c.h>
#include "compat.h"

#define FWSEND 1024

#ifdef LINUX26
#define FWDEV(x) &((x)->adapter->dev)
#else
#define FWDEV(x) I2C_NAME(x)
#endif

int cx25840_load_fw_hp(struct i2c_client *client);
int cx25840_load_fw_nohp(struct i2c_client *client);

#if defined(IVTV_FW_LOADER) && (defined(CONFIG_FW_LOADER) || defined(CONFIG_FW_LOADER_MODULE))
#define FWFILE "HcwMakoA.ROM"
static inline int load_audio_firmware(struct i2c_client *client)
{
	return cx25840_load_fw_hp(client);
}
#else
#define FWFILE "/lib/modules/HcwMakoA.ROM"
static inline int load_audio_firmware(struct i2c_client *client)
{
	return cx25840_load_fw_nohp(client);
}
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,23)
#include <linux/firmware.h>
#else
struct firmware {
	size_t size;
	u8 *data;
};
#define request_firmware(...) 1
#define release_firmware(...)
#endif
